/* -------------------------
   Or-scheduler instructions
   ------------------------- */

  PBOp(getwork_first_time,e)
    START_PARALLEL_GOAL(worker_id);
    while (GLOBAL_parallel_mode != EXECUTING_MODE) continue;
    SIMICS_SERVICE(START_COUNTER, 0);
    SIMICS_SERVICE(START_COUNTER, 3);
    make_root_choice_point();  
    if (get_work()) {
      SIMICS_SERVICE(STOP_COUNTER, 3);
      SIMICS_SERVICE(START_COUNTER, 1);
      goto shared_fail;
    }
  shared_end:
    SIMICS_SERVICE(STOP_COUNTER, 3);
    SIMICS_SERVICE(START_COUNTER, 5);
    /* while (LOCAL_top_cp != GLOBAL_root_cp) {
      MOVE_UP_ONE_CP(NULL);
    }
    */
    END_PARALLEL_GOAL(worker_id);
    if (worker_id == 0) {
      yapor_off();
      free_root_choice_point();
      goto fail;
    }
    SIMICS_SERVICE(STOP_COUNTER, 5);
    SIMICS_SERVICE(STOP_COUNTER, 0);
    while (GLOBAL_parallel_mode == EXECUTING_MODE) continue;
    PREG = GETWORK_FIRST_TIME;
    PREFETCH_OP(PREG);
    GONext();
  ENDPBOp();


  PBOp(getwork,ld)
    LOCK_OR_FRAME(LOCAL_top_or_fr);
    if (OrFr_alternative(LOCAL_top_or_fr) == NULL) {
      UNLOCK_OR_FRAME(LOCAL_top_or_fr);
#ifdef TABLING
      if (DepFr_leader_cp(LOCAL_top_dep_fr) == LOCAL_top_cp)
        goto completion;
#endif /* TABLING */
      SIMICS_SERVICE(STOP_COUNTER, 1);
      SIMICS_SERVICE(START_COUNTER, 3);
      if (get_work()) {
        SIMICS_SERVICE(STOP_COUNTER, 3);
        SIMICS_SERVICE(START_COUNTER, 1);
        goto shared_fail;
      }
      goto shared_end;
    }
    PREG = OrFr_alternative(LOCAL_top_or_fr);
    PREFETCH_OP(PREG);
    SIMICS_ATOMIC_SERVICE(ONE_MORE_TASK);
    GONext();
  ENDPBOp();


  /* The idea is to check whether all workers in the node are idle.
     If they are we can go ahead, otherwise we should call the scheduler. */
  PBOp(getwork_seq,ld)
    bitmap idle_on_cp;

    BITMAP_copy(idle_on_cp, GLOBAL_bm_idle_workers);
    BITMAP_insert(idle_on_cp, worker_id);
    LOCK_OR_FRAME(LOCAL_top_or_fr);
    if (OrFr_alternative(LOCAL_top_or_fr) == NULL || 
        ! BITMAP_subset(idle_on_cp, OrFr_members(LOCAL_top_or_fr))) {
      UNLOCK_OR_FRAME(LOCAL_top_or_fr);
      SIMICS_SERVICE(STOP_COUNTER, 1);
      SIMICS_SERVICE(START_COUNTER, 3);
      if (get_work()) {
	SIMICS_SERVICE(STOP_COUNTER, 3);
	SIMICS_SERVICE(START_COUNTER, 1);
	goto shared_fail;
      }
      goto shared_end;
    }
    PREG = OrFr_alternative(LOCAL_top_or_fr);
    PREFETCH_OP(PREG);
    SIMICS_ATOMIC_SERVICE(ONE_MORE_TASK);
    GONext();
  ENDPBOp();

  PBOp(sync,ld)
    if (! CUT_wait_until_leftmost()) 
      goto shared_fail;
    PREG = NEXTOP(PREG, ld);
    PREFETCH_OP(PREG);
    GONext();
  ENDPBOp();
