/* ----------------------------------
           General tab macros
   ---------------------------------- */

#ifdef YAPOR
#define SgFr_init_yapor_fields(SG_FR)            \
        SgFr_gen_worker(SG_FR) = worker_id;      \
        SgFr_gen_or_fr(SG_FR) = LOCAL_top_or_fr
#define DepFr_init_yapor_fields(DEP_FR)    \
        DepFr_top_chain_cp(DEP_FR) = NULL
#define YAPOR_SET_LOAD(CP_PTR)  SCH_set_load(CP_PTR)
#define direct_dependency(SG_FR, LEADER_CP)                            \
	if (SgFr_gen_worker(SG_FR) == worker_id) {                     \
          LEADER_CP = NORM_CP(SgFr_gen_cp(SG_FR));                     \
        } else {                                                       \
          or_fr_ptr aux_or_fr = SgFr_gen_or_fr(SG_FR);                 \
          while (! BITMAP_member(OrFr_members(aux_or_fr), worker_id))  \
            aux_or_fr = OrFr_next(aux_or_fr);                          \
          LEADER_CP = OrFr_node(aux_or_fr);                            \
	}
#define new_suspension_frame(SUSP_FR, WORKER, TOP_CP, TOP_CONS_CP, TOP_DEP, TOP_SG,  \
                             H_REG, B_REG, TR_REG, H_SIZE, B_SIZE, TR_SIZE)          \
        ALLOC_SUSPENSION_FRAME(SUSP_FR);                                             \
        SuspFr_susp_worker(SUSP_FR) = WORKER;                                        \
        SuspFr_top_cp(SUSP_FR) = TOP_CP;                                             \
        SuspFr_top_consumer_cp(SUSP_FR) = TOP_CONS_CP;                               \
        SuspFr_top_dep_fr(SUSP_FR) = TOP_DEP;                                        \
        SuspFr_top_sg_fr(SUSP_FR) = TOP_SG;                                          \
        SuspFr_global_reg(SUSP_FR) = (void *) H_REG;                                 \
        SuspFr_local_reg(SUSP_FR) = (void *) B_REG;                                  \
        SuspFr_trail_reg(SUSP_FR) = (void *) TR_REG;                                 \
        SuspFr_global_start(SUSP_FR) = alloc_suspension_block(H_SIZE);               \
        SuspFr_local_start(SUSP_FR) = alloc_suspension_block(B_SIZE);                \
        SuspFr_trail_start(SUSP_FR) = alloc_suspension_block(TR_SIZE);               \
        SuspFr_global_size(SUSP_FR) = H_SIZE;                                        \
        SuspFr_local_size(SUSP_FR) = B_SIZE;                                         \
        SuspFr_trail_size(SUSP_FR) = TR_SIZE
#else
#define SgFr_init_yapor_fields(SG_FR)
#define DepFr_init_yapor_fields(DEP_FR)
#define YAPOR_SET_LOAD(CP_PTR)
#define direct_dependency(SG_FR, LEADER_CP)                       \
	LEADER_CP = NORM_CP(SgFr_gen_cp(SG_FR))
#endif /* YAPOR */


#define new_subgoal_frame(SG_FR, BOTTOM_SG_NODE, GEN_CP, NEXT)              \
        { register ans_node_ptr ans_node;                                   \
          ALLOC_SUBGOAL_FRAME(SG_FR);                                       \
          INIT_LOCK(SgFr_lock(SG_FR));                                      \
          SgFr_gen_cp(SG_FR) = GEN_CP;                                      \
          SgFr_subgoal_trie(SG_FR) = BOTTOM_SG_NODE;                        \
          new_answer_trie_node(ans_node, 0, 0, 0, 0, 0, NULL, NULL, NULL);  \
          SgFr_answer_trie(SG_FR) = ans_node;                               \
          SgFr_first_answer(SG_FR) = NULL;                                  \
          SgFr_last_answer(SG_FR) = NULL;                                   \
          SgFr_completed(SG_FR) = 0;                                        \
          SgFr_init_yapor_fields(SG_FR);                                    \
          SgFr_next(SG_FR) = NEXT;                                          \
	}

#define new_dependency_frame(DEP_FR, CONS_CP, LEADER_CP, SG_FR, NEXT)  \
        ALLOC_DEPENDENCY_FRAME(DEP_FR);                                \
        INIT_LOCK(DepFr_lock(DEP_FR));                                 \
        DepFr_cons_cp(DEP_FR) = CONS_CP;                               \
        DepFr_leader_cp(DEP_FR) = LEADER_CP;                           \
        DepFr_sg_fr(DEP_FR) = SG_FR;                                   \
        DepFr_last_ans(DEP_FR) = NULL;                                 \
        DepFr_h_fz(DEP_FR) = H_FZ;                                     \
        DepFr_b_fz(DEP_FR) = B_FZ;                                     \
        DepFr_tr_fz(DEP_FR) = TR_FZ;                                   \
        DepFr_init_yapor_fields(DEP_FR);                               \
        DepFr_next(DEP_FR) = NEXT

#define new_table_entry(TE, SUBGOAL_TRIE)       \
        ALLOC_TABLE_ENTRY(TE);                  \
        TabEnt_subgoal_trie(TE) = SUBGOAL_TRIE

#define new_subgoal_trie_node(NODE, ENTRY, CHILD, PARENT, PREVIOUS, NEXT)  \
        ALLOC_SUBGOAL_TRIE_NODE(NODE);                                     \
        INIT_LOCK(TrNode_lock(NODE));                                      \
        TrNode_entry(NODE) = ENTRY;                                        \
        TrNode_child(NODE) = CHILD;                                        \
        TrNode_parent(NODE) = PARENT;                                      \
        TrNode_previous(NODE) = PREVIOUS;                                  \
        TrNode_next(NODE) = NEXT

#define new_answer_trie_node(NODE, INSTR, LTT, CUT, SEQ, ENTRY, CHILD, PARENT, NEXT)  \
        ALLOC_ANSWER_TRIE_NODE(NODE);                                                 \
        INIT_LOCK(TrNode_lock(NODE));                                                 \
        TrNode_instr(NODE) = opcode(INSTR);                                           \
        TrNode_ltt(NODE) = LTT;                                                       \
        TrNode_cut(NODE) = CUT;                                                       \
        TrNode_seq(NODE) = SEQ;                                                       \
        TrNode_op_instr(NODE) = INSTR;                                                \
        TrNode_entry(NODE) = ENTRY;                                                   \
        TrNode_child(NODE) = CHILD;                                                   \
        TrNode_parent(NODE) = PARENT;                                                 \
        TrNode_next(NODE) = NEXT


#ifdef TAGS_FAST_OPS  /* Tags_32Ops.h */
#define	TabTagBits             TagBits
#define TabNumberOfLowTagBits  LowTagBits
#define	TabVarTagBits          MKTAG(0x0,0)
#define	TabAtomTagBits         AtomTag
#define	TabNumberTagBits       NumberTag
#define	TabPairTagBits         MKTAG(0x5,3)
#define	TabApplTagBits         MKTAG(0x5,0)
#else
#define	TabTagBits             OOOOPPS!!!!!
#define TabNumberOfLowTagBits  OOOOPPS!!!!!
#define	TabVarTagBits          OOOOPPS!!!!!
#define	TabAtomTagBits         OOOOPPS!!!!!
#define	TabNumberTagBits       OOOOPPS!!!!!
#define	TabPairTagBits         OOOOPPS!!!!!
#define	TabApplTagBits         OOOOPPS!!!!!
#endif


#define NORM_CP(CP)  ((choiceptr)(CP))
#define GEN_CP(CP)   ((gen_cp_ptr)(CP))
#define CONS_CP(CP)  ((cons_cp_ptr)(CP))

#define MIN_REF(B1, B2)  ((B1 < B2) ? B1 : B2)
#define MAX_REF(B1, B2)  ((B1 > B2) ? B1 : B2)


#define TAG_AS_ANSWER_LEAF_NODE(NODE)  ((unsigned int)TrNode_parent(NODE) |= 0x1)
#define UNTAG_ANSWER_LEAF_NODE(NODE)   ((ans_node_ptr)((unsigned int)NODE & 0xfffffffe))
#define IS_ANSWER_LEAF_NODE(NODE)      ((unsigned int)TrNode_parent(NODE) & 0x1)


#define FREE_STACK_PUSH(ITEM, STACK)        *--STACK = (CELL)(ITEM)
#define STACK_TOP(STACK)                    *STACK
#define STACK_POP(STACK)                    *STACK++
#define STACK_EMPTY(STACK, STACK_BASE)      STACK == STACK_BASE
#define STACK_NOT_EMPTY(STACK, STACK_BASE)  STACK != STACK_BASE
#define STACK_PUSH(ITEM, STACK, STACK_TOP)              \
        *--STACK = (CELL)(ITEM);                        \
        if (STACK <= STACK_TOP)                         \
          abort_optyap("private auxiliary stack full")


#define MakeTableVarTerm(INDEX)    (INDEX << TabNumberOfLowTagBits)
#define VarIndexOfTableTerm(TERM)  (TERM >> TabNumberOfLowTagBits)
#define VarIndexOfTerm(TERM)       ((((CELL) TERM) - GLOBAL_table_var_enumerator(0))/sizeof(CELL))
#define IsTableVarTerm(TERM)       ((CELL) TERM) >= GLOBAL_table_var_enumerator(0) &&  \
                                   ((CELL) TERM) <= GLOBAL_table_var_enumerator(MAX_TABLE_VARS -1)
