/*************************************************************************
*									 *
*	 YAP Prolog 							 *
*									 *
*	Yap Prolog was developed at NCCUP - Universidade do Porto	 *
*									 *
* Copyright L.Damas, V.S.Costa and Universidade do Porto 1985-1997	 *
*									 *
**************************************************************************
*									 *
* File:		it_deep.c						 *
* Last rev:								 *
* mods:									 *
* comments:	Support for Iterative Deepening                          *
*									 *
*************************************************************************/
#ifdef SCCS
static char     SccsId[] = "%W% %G%";
#endif /* SCCS */

#include "Yap.h"

#ifdef DEPTH_LIMIT

#include "Yatom.h"

STD_PROTO(static Int p_get_depth_limit, (void));
STD_PROTO(static Int p_set_depth_limit, (void));

static Int p_get_depth_limit()
{
  return(unify_constant(ARG1, DEPTH));
}

static Int p_set_depth_limit()
{
  Term d = Deref(ARG1);

  if (IsVarTerm(d)) {
    Error(INSTANTIATION_ERROR, d, "set-depth_limit");
    return(FALSE);
  } else if (!IsIntTerm(d)) {
    Error(TYPE_ERROR_INTEGER, d, "set-depth_limit");
    return(FALSE);
  }

  YENV[E_DEPTH] = d;
  DEPTH = d;

  return(TRUE);
}

void InitItDeepenPreds()
{
	InitCPred("get_depth_limit", 1, p_get_depth_limit, SafePredFlag|SyncPredFlag);
	InitCPred("$set_depth_limit", 1, p_set_depth_limit, SyncPredFlag);
}

#endif
