/*************************************************************************
*									 *
*	 YAP Prolog 							 *
*									 *
*	Yap Prolog was developed at NCCUP - Universidade do Porto	 *
*									 *
* Copyright L.Damas, V.S.Costa and Universidade do Porto 1985-1997	 *
*									 *
**************************************************************************
*									 *
* File:		yapor.yap						 *
* Last rev:	8/2/88							 *
* mods:									 *
* comments:	support or-parallelism					 *
*									 *
*************************************************************************/

% ***************************
% * -------- YAPOR -------- *
% ***************************

default_sequential(X) :- $default_sequential(X), !.
default_sequential(_).


sequential(X) :- var(X), !,
                 write(user_error, '[ Error: argument to sequential/1 should be a predicate ]'),
                 nl(user_error),
                 fail.
sequential((A,B)) :- !, sequential(A), sequential(B).
sequential(A/N) :- integer(N), atom(A), !,
                   functor(T,A,N), $flags(T,F,F),
                   (
                     X is F /\ 8'000040, X =\= 0, !,
                     write(user_error, '[ Warning: '),
                     write(user_error, A/N),
                     write(user_error, ' is already declared as sequential ]'),
                     nl(user_error)
                   ;
                     X is F /\ 8'170000, X =:= 0, !, $sequential(T)
                   ;
                     write(user_error, '[ Error: '),
                     write(user_error, A/N),
                     write(user_error, ' cannot be declared as sequential ]'),
                     nl(user_error),
                     fail
                   ).
sequential(X) :- write(user_error, '[ Error: '),
                 write(user_error, X),
                 write(user_error, ' is an invalid argument to sequential/1 ]'),
                 nl(user_error),
                 fail.


